package info.aspirecn.iov.yysj.paramtransfer.inter;

import info.aspirecn.iov.yysj.paramtransfer.inter.common.Constant;
import info.aspirecn.iov.yysj.paramtransfer.inter.vo.YysjProduct;
import info.aspirecn.iov.yysj.paramtransfer.inter.vo.YysjUser;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(value = "cloud-yysj-servicenode-paramtransfer",url="${paramtransfer.url}")
public interface YysjUserActionInterface {
    @PostMapping("/getUser.do")
    @ApiOperation(value = "获取用户信息")
    @ApiImplicitParam(name = "userId", value = "获取用户信息", required = true, dataType = "String")
    public YysjUser getUser(@RequestParam("userId") String userId);

    @PostMapping("/getYysjProductIdByUserId.do")
    @ApiOperation(value = "根据用户id获取到云验平台产品id,需要删除缓存")
    @ApiImplicitParams({@ApiImplicitParam(name = "userId", value = "获取用户产品信息", required = true, dataType = "String"),
            @ApiImplicitParam(name = "type", value = "产品类型", required = true, dataType = "int")})
    public List<YysjProduct> getYysjProductIdByUserId(@RequestParam(name = "userId") String userId, @RequestParam(name = "type") int type);

    @PostMapping("/getSjjhProduct.do")
    @ApiOperation(value = "获取所有数据交互产品")
    public List<String> getSjjhProduct();

    @DeleteMapping("/delelteYysjByUserId.do")
    @ApiOperation(value = "根据用户id和产品id删除用户订购的云验产品")
    @ApiImplicitParams({@ApiImplicitParam(name = "userId", value = "获取用户产品信息", required = true, dataType = "String"),
            @ApiImplicitParam(name = "productId", value = "产品Id", required = true, dataType = "String")})
    public int delelteYysjByUserId(@RequestParam(name = "userId") String userId, @RequestParam(name = "productId") String productId);
}